## telegram-bot-api 9.2+tdlib1.8.52

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,17 +1,6 @@
-cmake_minimum_required(VERSION 3.0.2 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.10 FATAL_ERROR)
 
-if (POLICY CMP0065)
-  # do not export symbols from executables
-  # affects compiler checks in project(), so must be set before it
-  cmake_policy(SET CMP0065 NEW)
-endif()
-
-project(TelegramBotApi VERSION 5.4.1 LANGUAGES CXX)
-
-if (POLICY CMP0069)
-  option(TELEGRAM_BOT_API_ENABLE_LTO "Use \"ON\" to enable Link Time Optimization.")
-  set(TD_ENABLE_LTO "${TELEGRAM_BOT_API_ENABLE_LTO}" CACHE STRING "Enable LTO" FORCE)
-endif()
+project(TelegramBotApi VERSION 9.2 LANGUAGES CXX)
 
 add_subdirectory(td EXCLUDE_FROM_ALL)
 
@@ -24,14 +13,6 @@
   set(CMAKE_INSTALL_BINDIR "bin")
 endif()
 
-if (POLICY CMP0054)
-  # do not expand quoted arguments
-  cmake_policy(SET CMP0054 NEW)
-endif()
-if (POLICY CMP0060)
-  # link libraries by full path
-  cmake_policy(SET CMP0060 NEW)
-endif()
 if (POLICY CMP0074)
   # use environment variables to find libraries
   cmake_policy(SET CMP0074 NEW)
@@ -40,8 +21,7 @@
 include(PreventInSourceBuild)
 prevent_in_source_build()
 
-if (POLICY CMP0069 AND TELEGRAM_BOT_API_ENABLE_LTO)
-  cmake_policy(SET CMP0069 NEW)
+if (TELEGRAM_BOT_API_ENABLE_LTO)
   include(CheckIPOSupported)
   check_ipo_supported(RESULT IPO_SUPPORTED LANGUAGES CXX)
   if (IPO_SUPPORTED)
@@ -73,6 +53,9 @@
     elseif (APPLE)
       set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-no_pie")
     endif()
+    include(AddCXXCompilerFlag)
+    add_cxx_compiler_flag("-static-libstdc++")
+    add_cxx_compiler_flag("-static-libgcc")
   endif()
 endif()
 
@@ -85,6 +68,7 @@
   telegram-bot-api/HttpStatConnection.cpp
   telegram-bot-api/Query.cpp
   telegram-bot-api/Stats.cpp
+  telegram-bot-api/Watchdog.cpp
   telegram-bot-api/WebhookActor.cpp
 
   telegram-bot-api/Client.h
@@ -95,6 +79,7 @@
   telegram-bot-api/HttpStatConnection.h
   telegram-bot-api/Query.h
   telegram-bot-api/Stats.h
+  telegram-bot-api/Watchdog.h
   telegram-bot-api/WebhookActor.h
 )
