=== debian/changelog ===
telegram-bot-api (9.2+tdlib1.8.52) plucky; urgency=medium

  * New upstreams: telegram-bot-api 9.2, TDLib 1.8.36
  * Refresh packaging

 -- Chris <dpkg@chris-nz.com>  Thu, 25 Sep 2025 21:38:35 +1200

telegram-bot-api (5.4.1~chris1) impish; urgency=medium

  * Huge bump of version

 -- Chris <dpkg@chris-nz.com>  Mon, 29 Nov 2021 21:47:46 +1300
