=== debian/control ===
Source: telegram-bot-api
Maintainer: Chris <dpkg@chris-nz.com>
Section: misc
Priority: optional
Standards-Version: 4.5.1
Homepage: https://github.com/tdlib/telegram-bot-api
Build-Depends: dh-exec (>=0.3), debhelper (>=9), zlib1g-dev, libssl-dev, gperf, cmake, default-jdk

# jdk sadly needed because of enabling build for jni

# git is not needed because it just creates a useless commit, i think?

# php is not needed because that documentation
# would require manual generation (and is available online)

Package: libtdjson
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: tdlib (= 1.8.36)
Description: Cross-platform Telegram client library - runtime
 TDLib (Telegram Database library) is a cross-platform library for
 building Telegram clients.
 It can be easily used from almost any programming language.
 .
 This package contains the runtime library files needed to run software
 using TDLib.

Package: libtdjson-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libtdjson (= ${binary:Version})
Conflicts: tl-parser
Provides: libtdjson-utils (= 1.8.36)
Description: Utils for TDLib
 TDLib (Telegram Database library) is a cross-platform library for
 building Telegram clients.
 It can be easily used from almost any programming language.
 .
 This package provides two tools for developing TDLib: tg-cli (to connect
 using MTProto as a Telegram client), tl-parser (to compile TDLib's
 Type Language spec files), and binlog_dump (to dump binary logs).

Package: libtdjson-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ilibtdjson (= ${binary:Version})
Provides: libtdjson-dev (= 1.8.36)
Description: Cross-platform Telegram client library - development files
 TDLib (Telegram Database library) is a cross-platform library for
 building Telegram clients.
 It can be easily used from almost any programming language.
 .
 This package contains the header and development files needed to build
 programs and packages using TDLib.

Package: libtdjson-extra-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libtdjson-dev
Provides: libtdjson-extra-dev (= 1.8.36)
Description: Cross-platform Telegram client library - extra development files
 TDLib (Telegram Database library) is a cross-platform library for
 building Telegram clients.
 It can be easily used from almost any programming language.
 .
 This package contains the extra header and development files needed
 to build programs and packages using TDLib's less public features.

Package: libtdjson-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, libtdjson-dev
Description: Cross-platform Telegram client library - example code
 TDLib (Telegram Database library) is a cross-platform library for
 building Telegram clients.
 It can be easily used from almost any programming language.
 .
 This package provides example code illustrating the use of TDLib.

Package: telegram-bot-api
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser
Description: Telegram bot API http server
 The Telegram Bot API provides an HTTP API for creating Telegram Bots.
